package dev.shadowsoffire.apotheosis.spawn.compat;

import net.minecraft.resources.ResourceLocation;
import mezz.jei.api.recipe.category.IRecipeCategory;
import mezz.jei.api.registration.IRecipeCategoryRegistration;
import mezz.jei.api.registration.IRecipeCatalystRegistration;
import java.util.Iterator;
import net.minecraft.world.item.SpawnEggItem;
import net.minecraft.world.item.Item;
import net.minecraftforge.registries.ForgeRegistries;
import net.minecraft.ChatFormatting;
import net.minecraft.world.item.enchantment.Enchantments;
import net.minecraft.network.chat.MutableComponent;
import mezz.jei.api.ingredients.IIngredientType;
import net.minecraft.network.chat.Component;
import mezz.jei.api.constants.VanillaTypes;
import net.minecraft.world.level.ItemLike;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.level.block.Blocks;
import dev.shadowsoffire.apotheosis.spawn.SpawnerModule;
import java.util.List;
import mezz.jei.api.recipe.RecipeType;
import net.minecraft.world.item.crafting.Ingredient;
import java.util.Collection;
import dev.shadowsoffire.apotheosis.spawn.modifiers.SpawnerModifier;
import java.util.ArrayList;
import dev.shadowsoffire.apotheosis.Apoth;
import net.minecraft.client.Minecraft;
import dev.shadowsoffire.apotheosis.Apotheosis;
import mezz.jei.api.registration.IRecipeRegistration;
import mezz.jei.api.JeiPlugin;
import mezz.jei.api.IModPlugin;

@JeiPlugin
public class SpawnerJEIPlugin implements IModPlugin
{
    public void registerRecipes(final IRecipeRegistration reg) {
        if (!Apotheosis.enableSpawner) {
            return;
        }
        final List<SpawnerModifier> recipes = new ArrayList<SpawnerModifier>(Minecraft.m_91087_().f_91073_.m_7465_().m_44013_(Apoth.RecipeTypes.MODIFIER));
        recipes.sort((r1, r2) -> (r1.getOffhandInput() == Ingredient.f_43901_) ? ((r2.getOffhandInput() == Ingredient.f_43901_) ? 0 : -1) : 1);
        reg.addRecipes((RecipeType)SpawnerCategory.TYPE, (List)recipes);
        if (SpawnerModule.spawnerSilkLevel == -1) {
            reg.addIngredientInfo((Object)new ItemStack((ItemLike)Blocks.f_50085_), (IIngredientType)VanillaTypes.ITEM_STACK, new Component[] { (Component)Component.m_237115_("info.apotheosis.spawner.no_silk") });
        }
        else if (SpawnerModule.spawnerSilkLevel == 0) {
            reg.addIngredientInfo((Object)new ItemStack((ItemLike)Blocks.f_50085_), (IIngredientType)VanillaTypes.ITEM_STACK, new Component[] { (Component)Component.m_237115_("info.apotheosis.spawner.always_drop") });
        }
        else {
            reg.addIngredientInfo((Object)new ItemStack((ItemLike)Blocks.f_50085_), (IIngredientType)VanillaTypes.ITEM_STACK, new Component[] { (Component)Component.m_237110_("info.apotheosis.spawner", new Object[] { ((MutableComponent)Enchantments.f_44985_.m_44700_(SpawnerModule.spawnerSilkLevel)).m_130940_(ChatFormatting.DARK_BLUE).getString() }) });
        }
        if (SpawnerModule.enableCapturingEnchantmentJeiInfo) {
            for (final Item i : ForgeRegistries.ITEMS) {
                if (i instanceof SpawnEggItem) {
                    reg.addIngredientInfo((Object)new ItemStack((ItemLike)i), (IIngredientType)VanillaTypes.ITEM_STACK, new Component[] { (Component)Component.m_237115_("info.apotheosis.capturing") });
                }
            }
        }
    }
    
    public void registerRecipeCatalysts(final IRecipeCatalystRegistration reg) {
        if (!Apotheosis.enableSpawner) {
            return;
        }
        reg.addRecipeCatalyst(new ItemStack((ItemLike)Blocks.f_50085_), new RecipeType[] { SpawnerCategory.TYPE });
    }
    
    public void registerCategories(final IRecipeCategoryRegistration reg) {
        if (!Apotheosis.enableSpawner) {
            return;
        }
        reg.addRecipeCategories(new IRecipeCategory[] { (IRecipeCategory)new SpawnerCategory(reg.getJeiHelpers().getGuiHelper()) });
    }
    
    public ResourceLocation getPluginUid() {
        return new ResourceLocation("apotheosis", "spawner");
    }
}
